package com.inteligr8.git;

import java.util.List;

import org.eclipse.jgit.api.CloneCommand;
import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.api.errors.InvalidRemoteException;
import org.eclipse.jgit.api.errors.TransportException;
import org.eclipse.jgit.lib.Repository;
import org.eclipse.jgit.transport.RemoteConfig;
import org.eclipse.jgit.transport.URIish;

public class CachedGit extends Git {
	
	public CachedGit(Git git) {
		super(git.getRepository());
	}
	
	public CachedGit(CloneCommand clone) throws TransportException, InvalidRemoteException, GitAPIException {
		super(clone.call().getRepository());
	}
	
	public CachedGit(Repository repo) {
		super(repo);
	}
	
	public URIish getRemoteUrl(String remoteName) throws GitAPIException {
		List<RemoteConfig> configs = this.remoteList().call();
		for (RemoteConfig config : configs)
			if (config.getName().equals(remoteName))
				return config.getURIs().iterator().next();
		return null;
	}
	
	@Override
	public void close() {
		LocalRepositoryCache.getInstance().release(this);
	}

}
